import _regeneratorRuntime from "@babel/runtime/regenerator";
import _asyncToGenerator from "@babel/runtime/helpers/esm/asyncToGenerator";
import { Phases, symbol } from './constants';
export var executeReadModel = /*#__PURE__*/function () {
  var _ref2 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee2(_ref) {
    var promise, createQuery, transformEvents, queryExecutor, performAcknowledge, acknowledgePromise, _yield$acknowledgePro, projectionError, error, result;

    return _regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            promise = _ref.promise, createQuery = _ref.createQuery, transformEvents = _ref.transformEvents;

            if (!(promise[symbol].phase < Phases.RESOLVER)) {
              _context2.next = 3;
              break;
            }

            throw new TypeError(promise[symbol].phase);

          case 3:
            queryExecutor = null;
            performAcknowledge = null;
            acknowledgePromise = new Promise(function (resolve) {
              return performAcknowledge = /*#__PURE__*/function () {
                var _ref3 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee(result) {
                  return _regeneratorRuntime.wrap(function _callee$(_context) {
                    while (1) {
                      switch (_context.prev = _context.next) {
                        case 0:
                          _context.next = 2;
                          return resolve(result);

                        case 2:
                          return _context.abrupt("return", _context.sent);

                        case 3:
                        case "end":
                          return _context.stop();
                      }
                    }
                  }, _callee);
                }));

                return function performAcknowledge(_x2) {
                  return _ref3.apply(this, arguments);
                };
              }();
            });
            _context2.prev = 6;
            queryExecutor = createQuery({
              viewModels: [],
              readModels: [{
                name: promise[symbol].name,
                projection: promise[symbol].projection,
                resolvers: promise[symbol].resolvers,
                connectorName: 'ADAPTER_NAME'
              }],
              readModelConnectors: {
                ADAPTER_NAME: promise[symbol].adapter
              },
              getRemainingTimeInMillis: function getRemainingTimeInMillis() {
                return 0x7fffffff;
              },
              snapshotAdapter: null,
              eventstoreAdapter: {
                getSecretsManager: function getSecretsManager() {
                  return promise[symbol].secretsManager;
                }
              },
              performAcknowledge: performAcknowledge
            });
            _context2.next = 10;
            return queryExecutor.sendEvents({
              modelName: promise[symbol].name,
              events: transformEvents(promise[symbol].events)
            });

          case 10:
            _context2.next = 12;
            return acknowledgePromise;

          case 12:
            _yield$acknowledgePro = _context2.sent;
            projectionError = _yield$acknowledgePro.result.error;

            if (!(projectionError != null)) {
              _context2.next = 18;
              break;
            }

            error = new Error(projectionError.message);
            error.stack = projectionError.stack;
            throw error;

          case 18:
            _context2.next = 20;
            return queryExecutor.read({
              modelName: promise[symbol].name,
              resolverName: promise[symbol].resolverName,
              resolverArgs: promise[symbol].resolverArgs,
              jwt: promise[symbol].jwt
            });

          case 20:
            result = _context2.sent;
            promise[symbol].resolve(result);
            _context2.next = 27;
            break;

          case 24:
            _context2.prev = 24;
            _context2.t0 = _context2["catch"](6);
            promise[symbol].reject(_context2.t0);

          case 27:
            _context2.prev = 27;

            if (!queryExecutor) {
              _context2.next = 31;
              break;
            }

            _context2.next = 31;
            return queryExecutor.dispose();

          case 31:
            return _context2.finish(27);

          case 32:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2, null, [[6, 24, 27, 32]]);
  }));

  return function executeReadModel(_x) {
    return _ref2.apply(this, arguments);
  };
}();
//# sourceMappingURL=execute-read-model.js.map